var NSLibrary = NSLibrary || {};
NSLibrary.Client = NSLibrary.Client || {};
NSLibrary.Client.Lock = NSLibrary.Client.Lock || {};

(function(lock) {

	lock.lockWindow = -1;
	lock.lockInterval = undefined;

	// enforces Lock
	// -------------
	function enforceLock() {
		chrome.windows.get(lock.lockWindow, {}, function(wnd) {
			if (wnd) {
				chrome.windows.update(lock.lockWindow, {focused: true, state: 'fullscreen'});
			}else {
				lock.unlockClient();
				lock.lockClient();
			}
		});
	}
	/** Locks a client. 	*/
	lock.lockClient = function() {
		if (lock.lockWindow < 0) {
			chrome.windows.create({url: 'lock.html', top: 0, left: 0, type: 'popup', width: screen.width, height: screen.height}, function(wnd) {
				lock.lockWindow = wnd.id;
				lock.lockInterval = window.setInterval(enforceLock, 500);
			});
		}
	};
	/** Unlocks a client. 	*/
	lock.unlockClient = function() {
		window.clearInterval(lock.lockInterval);
		if (lock.lockWindow>-1){
			chrome.windows.remove(lock.lockWindow);
		}
		lock.lockWindow = -1;
	};


})(NSLibrary.Client.Lock);
